import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class network_toy extends PApplet {Network net;
int NODESIZE = 20;
int NODES = 20;

public void setup() {
  size(400,400);
  background(255);
  PFont f = loadFont("BitstreamVeraSerif-Roman-28.vlw");
  textFont(f, 28);
  smooth();

  net = new Network();
  net.generate(20);
  frameRate(24);
}

public void draw() {
  background(255);
  if (mousePressed && GRABBEDNODE == null) {
    // net.doClick(mouseX, mouseY);
    GRABBEDNODE = net.getClicked(mouseX, mouseY);
  }
  net.update();
  net.drawme();  
}

Node GRABBEDNODE;
public void mouseDragged() {
  if (GRABBEDNODE == null) {
    GRABBEDNODE = net.getClicked(mouseX, mouseY);
  }
  
  if (GRABBEDNODE != null) {
    GRABBEDNODE.move(mouseX, mouseY);
  }
}

public void mouseReleased() {
  net.clearClicks();
  if (GRABBEDNODE != null) {
    GRABBEDNODE.setColor(false);
    GRABBEDNODE = null;  
  }
}

class Network {
  ArrayList nodes;
  boolean moving;
  Network() {
    nodes = new ArrayList();
  }  
  public void add(Node n) {
    nodes.add(n);  
  }
  public Node head() {
    return (Node)nodes.get(0);
  }
  public void generate(int node_count) {
    nodes = new ArrayList();

    for (int n=0;n<node_count;n++) {
      add(new Node(random(width-NODESIZE),random(height-NODESIZE),NODESIZE));
    }
    moving = true;
    update();    
    moving = false;
  }
  public Node getClicked(float x, float y) {
    for (int i=0;i<nodes.size();i++) {
      Node n = (Node)nodes.get(i);
      if (n.isHitting(x,y)) {
        n.setColor(true);
        moving = true;
        return n;
      }
    }
    return null;
  }
  public void clearClicks() {
    moving = false;
    for (int i=0;i<nodes.size();i++) {
      ((Node)nodes.get(i)).setColor(false);
    } 
  }
  public void doClick(float x, float y) {
    Node n = getClicked(x,y);
    if (n != null) n.setColor(true);
  }
  public void update() {
    if (moving) {
      text("updating...",15,15);
      for (int i=0;i<nodes.size();i++) {
        ((Node)nodes.get(i)).setNearest(nodes, i+1);
      }
    }
  }
  public void drawme() {
    for (int i=0;i<nodes.size();i++) {
      ((Node)nodes.get(i)).drawme();
    }
  }  
}

class NearNode {
  Node n;
  float d;
  NearNode (Node _n, float _d) {
    n=_n;
    d=_d;
  }
}

int MAXNEIGHBORS = 30;
class Node {
  float x,y,hw,cx,cy;
  float hitx, hity;
  float range;
  int fil;
  NearNode[] cons;
  Node (float _x, float _y, float _hw) {
    x=_x;
    y=_y;
    hw = _hw;
    cx = x + hw/2;
    cy = y + hw/2;
    setColor(false);
    range = 140;
    cons = new NearNode[MAXNEIGHBORS];
  }
  public void setColor(boolean clicked) {
    if (clicked) {
      fil = color(255,100,100);
    }
    else
      fil = color(100);
  }  
  public boolean isHitting(float nx, float ny) {
    if (nx <= x+hw && nx >= x && ny >= y && ny <= y + hw) {
      hitx = nx - x;
      hity = ny - y;
      return true;  
    }
    return false;
  }
  public float getDist(float nx, float ny) {
    return dist(cx,cy,nx,ny);
  }  
  public void setNearest(ArrayList nodes, int starting_at) {
    cons = new NearNode[MAXNEIGHBORS];
    float maxmin = 0;
    for (int n=starting_at;n<nodes.size();n++) {
      Node nod = (Node)nodes.get(n);
      float nd = nod.getDist(cx,cy);
      if (nd < range) {
        if (nod.addNeighbor(this, nd)) {
          addNeighbor(nod, nd);
        }
      }        
    }
  }  
  
  public boolean addNeighbor(Node n, float d) {
    // Simple bubble sort to find nearest 4 neighbors.
    NearNode _temp;
    boolean isAdded = false;
    for (int c=0;c<cons.length;c++) {
      if (cons[c] == null) {
        cons[c] = new NearNode(n, d);
        return true;
      }
      else {
        if (d < cons[c].d) {
          _temp = cons[c];
          cons[c] = new NearNode(n, d);
          n = _temp.n;
          d = _temp.d;
          isAdded = true;
        }
      }
    }
    return isAdded;
  }
  
  public void move(float nx, float ny) {
    x = nx - hitx;
    y = ny - hity;  
    cx = x + hw/2;
    cy = y + hw/2;
  }
  public void drawme() {
    stroke(0);
    
    strokeWeight(1);
    noFill();
    //ellipse(cx,cy,range,range);
    for (int c=0;c<cons.length;c++) {
      if (cons[c]!=null) {
        //strokeWeight(250/(cons[c].d > 10 ? cons[c].d : 10));
        strokeWeight((cons[c].d - (range + 5)) / -20);
        line(cx,cy,cons[c].n.cx, cons[c].n.cy);
      }
    }
    
    strokeWeight(3);
    fill(fil);
    rect(x,y,hw,hw);
    
  }  
}

  static public void main(String args[]) {     PApplet.main(new String[] { "network_toy" });  }}